require 'net/http'
require 'uri'
require 'time'
require 'nkf'
require 'tmpdir'
require 'pathname'

Net::HTTP.version_1_2

class XypicClass
	def initialize
		@ini = ""
		@log = ""
		
		@url = "http://ftp.riken.go.jp/archives/CTAN/macros/generic/diagrams/xypic/xy.zip"
		@localfile = "xy.zip";
		@size = 0
		@success = false
		@definstall = true
	end
	
	def info
		return [{"softname" => "Xy-pic", "info" => "}Ȃǂ`ɕ֗TeX}ND"}]
	end
	
	
	def plugin_init(ini,log)
		@ini = ini
		@log = log
	end
	
	
	def reboot?()
		return false
	end
	
	
	def set?(soft)
		return false
	end
	
	
	def set(hwnd,soft)
		return
	end
	
	
	def get_info(hwnd)
		Log("Xy-pic̏擾Jn")
		if AbTeXinst::Setting::use_network? == false then
			begin
			@definstall = File.exist?(AbTeXinst::Setting::hozon_dir + @localfile);
			rescue
				@definstall = false;
			end
			return true;
		end
		uri = URI.parse(@url)
		if uri.scheme != "http" then
			Log("httpłȂƂ܂D")
			return false
		end
		AbTeXinst::add_message(hwnd,"\r\n\r\nXy-pic̏擾Jn\r\n")
		response = nil
		
		proxy = AbTeXinst::Setting::proxy;
		if proxy == nil then
			proxy = AbTeXinst::get_IEproxy_info;
		end
		if proxy == nil or proxy["server"] == "" then
			proxy = {"server" => nil,"port" => nil};
		end
		AbTeXinst::add_message(hwnd,"" + uri.host + "ɐڑ擾܂D\r\n");
		Net::HTTP::Proxy(proxy["server"],proxy["port"]).start(uri.host){|http|
			response = http.head(uri.path)
		}
		
		
		if response == nil then
			AbTeXinst::add_message(hwnd,"擾Ɏs\r\n")
			Log("擾Ɏs")
			return false
		end
		
		
		@size = response['Content-Length'].to_i
		nettime = Time.parse(response['last-modified']) + 120
		begin
			localtime = File.atime(AbTeXinst::Setting::hozon_dir + @localfile);
			@definstall = (localtime < nettime)
		rescue
			@definstall = true
		end
		
		Log("Xy-pic̏擾I")
		AbTeXinst::add_message(hwnd,"\r\n")
		@success = true
		return true
	end
	
	
	def download_data(soft)
		if AbTeXinst::Setting::use_network? == 0 then
			return {
				"success" => true,
				"download_files" => []};
		else
			return {
				"success" => @success,
				"download_files" => [{
					"url" => @url,
					"file" => @localfile,
					"size" => @size}]}
		end
	end
	
	
	def default?(soft)
		return @definstall
	end
	
	
	def install(hwnd,soft,dlresult)
		Log("Xypic̃CXg[");
		if AbTeXinst::Setting::use_network? == true then
			if dlresult[@url] == nil or dlresult[@url] != AbTeXinst::SUCCESS then
				return false
			end
		end
		
		Dir.mktmpdir{|tmpdir|
			from = AbTeXinst::Setting::hozon_dir + @localfile;
			AbTeXinst::add_message(hwnd,"Xy-pic̃CXg[cc");
			if AbTeXinst::zipdlg(hwnd,from,tmpdir) == false then
				AbTeXinst::add_message(hwnd"s\r\n");
				Log("Xy-pic̃CXg[ɎsF" + @localfile + "̓WJɎs");
			end
			
			# glob̓fBNg̋؂肪/łȂƂ߂ۂD
			
			tmpdir = Dir.glob(Pathname(tmpdir).to_s + '/*')[0];
			
			texmf = AbTeXinst::Setting::install_dir + "share/texmf-local/";
			# Macros
			FileUtils.mkdir_p(texmf + "tex/generic/xypic");
			FileUtils.cp(Dir.glob(tmpdir + "/texinputs/*"),texmf + "tex/generic/xypic");
			# Metric
			FileUtils.mkdir_p(texmf + "fonts/tfm/public/xypic");
			FileUtils.cp(Dir.glob(tmpdir + "/texfonts/*.tfm"),texmf + "fonts/tfm/public/xypic");
			# METAFONT
			FileUtils.mkdir_p(texmf + "fonts/source/public/xypic");
			FileUtils.cp(Dir.glob(tmpdir + "/mfinputs/*.mf"),texmf + "fonts/source/public/xypic");
			# Type1 fonts
			FileUtils.mkdir_p(texmf + "fonts/type1/public/xypic");
			FileUtils.cp(Dir.glob(tmpdir + "/type1/*.pfb"),texmf + "fonts/type1/public/xypic");
			# PS Font Metric
			FileUtils.mkdir_p(texmf + "fonts/pfm/public/xypic");
			FileUtils.cp(Dir.glob(tmpdir + "/pfm/*.pfm"),texmf + "fonts/pfm/public/xypic");
			# Adobe Metric
			FileUtils.mkdir_p(texmf + "fonts/afm/public/xypic");
			FileUtils.cp(Dir.glob(tmpdir + "/afm/*.afm"),texmf + "fonts/afm/public/xypic");
			# PS Font Map
			FileUtils.mkdir_p(texmf + "fonts/map/dvips/xypic");
			FileUtils.cp(Dir.glob(tmpdir + "ps/*"),texmf + "fonts/map/dvips/xypic");
			# PDF Font Map
			FileUtils.mkdir_p(texmf + "fonts/enc/dvips/xypic");
			FileUtils.cp(Dir.glob(tmpdir + "enc/*"),texmf + "fonts/enc/dvips/xypic");
			# Docs
			FileUtils.mkdir_p(texmf + "doc/generic/xypic");
			FileUtils.cp(Dir.glob(tmpdir + "doc/*"),texmf + "doc/generic/xypic");
		}
		
		if system('updmap --add xypic.map') == false then
			Log("xypic.map̓o^Ɏs");
		end

		AbTeXinst::add_message(hwnd,"\r\n")
		Log("Xy-pic̃CXg[ɐ")
		return true
	end
	
private
	def Log(l)
		begin
			fp = File.open(@log,"a+")
		rescue
			return
		end
		fp.write(l + "\n");
		fp.close()
	end
	
end


Xypic = XypicClass.new

